dnl Copyright (C) 2004-2008 by Carnegie Mellon University.
dnl
dnl @OPENSOURCE_HEADER_START@
dnl
dnl Use of the SILK system and related source code is subject to the terms
dnl of the following licenses:
dnl
dnl GNU Public License (GPL) Rights pursuant to Version 2, June 1991
dnl Government Purpose License Rights (GPLR) pursuant to DFARS 252.225-7013
dnl
dnl NO WARRANTY
dnl
dnl ANY INFORMATION, MATERIALS, SERVICES, INTELLECTUAL PROPERTY OR OTHER
dnl PROPERTY OR RIGHTS GRANTED OR PROVIDED BY CARNEGIE MELLON UNIVERSITY
dnl PURSUANT TO THIS LICENSE (HEREINAFTER THE "DELIVERABLES") ARE ON AN
dnl "AS-IS" BASIS. CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY
dnl KIND, EITHER EXPRESS OR IMPLIED AS TO ANY MATTER INCLUDING, BUT NOT
dnl LIMITED TO, WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE,
dnl MERCHANTABILITY, INFORMATIONAL CONTENT, NONINFRINGEMENT, OR ERROR-FREE
dnl OPERATION. CARNEGIE MELLON UNIVERSITY SHALL NOT BE LIABLE FOR INDIRECT,
dnl SPECIAL OR CONSEQUENTIAL DAMAGES, SUCH AS LOSS OF PROFITS OR INABILITY
dnl TO USE SAID INTELLECTUAL PROPERTY, UNDER THIS LICENSE, REGARDLESS OF
dnl WHETHER SUCH PARTY WAS AWARE OF THE POSSIBILITY OF SUCH DAMAGES.
dnl LICENSEE AGREES THAT IT WILL NOT MAKE ANY WARRANTY ON BEHALF OF
dnl CARNEGIE MELLON UNIVERSITY, EXPRESS OR IMPLIED, TO ANY PERSON
dnl CONCERNING THE APPLICATION OF OR THE RESULTS TO BE OBTAINED WITH THE
dnl DELIVERABLES UNDER THIS LICENSE.
dnl
dnl Licensee hereby agrees to defend, indemnify, and hold harmless Carnegie
dnl Mellon University, its trustees, officers, employees, and agents from
dnl all claims or demands made against them (and any related losses,
dnl expenses, or attorney's fees) arising out of, or relating to Licensee's
dnl and/or its sub licensees' negligent use or willful misuse of or
dnl negligent conduct or willful misconduct regarding the Software,
dnl facilities, or other rights or assistance granted by Carnegie Mellon
dnl University under this License, including, but not limited to, any
dnl claims of product liability, personal injury, death, damage to
dnl property, or violation of any laws or regulations.
dnl
dnl Carnegie Mellon University Software Engineering Institute authored
dnl documents are sponsored by the U.S. Department of Defense under
dnl Contract F19628-00-C-0003. Carnegie Mellon University retains
dnl copyrights in all material produced under this contract. The U.S.
dnl Government retains a non-exclusive, royalty-free license to publish or
dnl reproduce these documents, or allow others to do so, for U.S.
dnl Government purposes only pursuant to the copyright license under the
dnl contract clause at 252.227.7013.
dnl
dnl @OPENSOURCE_HEADER_END@

dnl RCSIDENT("$SiLK: acinclude.m4 13082 2008-11-21 14:44:53Z mthomas $")

# ---------------------------------------------------------------------------
# SILK_AC_BASIC_HEADERS
#
#    Find some standard headers
#
AC_DEFUN([SILK_AC_BASIC_HEADERS],[
    # we have a bunch of these because not all versions of autoconf
    # support substitutions with embedded newlines
    AC_SUBST(SK_BASIC_HEADERS_01)
    AC_SUBST(SK_BASIC_HEADERS_02)
    AC_SUBST(SK_BASIC_HEADERS_03)
    AC_SUBST(SK_BASIC_HEADERS_04)
    AC_SUBST(SK_BASIC_HEADERS_05)
    AC_SUBST(SK_BASIC_HEADERS_06)
    AC_SUBST(SK_BASIC_HEADERS_07)
    AC_SUBST(SK_BASIC_HEADERS_08)
    AC_SUBST(SK_BASIC_HEADERS_09)
    AC_SUBST(SK_BASIC_HEADERS_10)
    AC_SUBST(SK_BASIC_HEADERS_11)
    AC_SUBST(SK_BASIC_HEADERS_12)
    AC_SUBST(SK_BASIC_HEADERS_13)
    AC_SUBST(SK_BASIC_HEADERS_14)
    AC_SUBST(SK_BASIC_HEADERS_15)
    AC_SUBST(SK_BASIC_HEADERS_16)
    AC_SUBST(SK_BASIC_HEADERS_17)
    AC_SUBST(SK_BASIC_HEADERS_18)
    AC_SUBST(SK_BASIC_HEADERS_19)
    AC_SUBST(SK_BASIC_HEADERS_20)
    AC_SUBST(SK_BASIC_HEADERS_21)
    AC_SUBST(SK_BASIC_HEADERS_22)
    AC_SUBST(SK_BASIC_HEADERS_23)
    AC_SUBST(SK_BASIC_HEADERS_24)
    AC_SUBST(SK_BASIC_HEADERS_25)
    SK_BASIC_HEADERS=""

    AC_CHECK_HEADER([stdio.h],
        [SK_BASIC_HEADERS="$SK_BASIC_HEADERS <stdio.h>"],
        [AC_MSG_ERROR([Cannot find <stdio.h>])])
    AC_CHECK_HEADER([sys/types.h],
        [SK_BASIC_HEADERS="$SK_BASIC_HEADERS <sys/types.h>"])
    AC_CHECK_HEADER([stddef.h],
        [SK_BASIC_HEADERS="$SK_BASIC_HEADERS <stddef.h>"])
    AC_CHECK_HEADER([inttypes.h],
        [SK_BASIC_HEADERS="$SK_BASIC_HEADERS <inttypes.h>"],
        [AC_CHECK_HEADER([stdint.h],
            [SK_BASIC_HEADERS="$SK_BASIC_HEADERS <stdint.h>"])])
    AC_CHECK_HEADER([limits.h],
        [SK_BASIC_HEADERS="$SK_BASIC_HEADERS <limits.h>"])
    AC_CHECK_HEADER([stdarg.h],
        [SK_BASIC_HEADERS="$SK_BASIC_HEADERS <stdarg.h>"])
    AC_CHECK_HEADER([pthread.h],
        [SK_BASIC_HEADERS="$SK_BASIC_HEADERS <pthread.h>"])
    AC_CHECK_HEADER([netinet/in.h],
        [SK_BASIC_HEADERS="$SK_BASIC_HEADERS <netinet/in.h>"])
    AC_CHECK_HEADER([assert.h],
        [SK_BASIC_HEADERS="$SK_BASIC_HEADERS <assert.h>"])
])# SILK_AC_BASIC_HEADERS


# ---------------------------------------------------------------------------
# SILK_AC_CHECK_GETOPT
#
#    See if <getopt.h> exists and provides getopt_long_only
#
AC_DEFUN([SILK_AC_CHECK_GETOPT],[
    AC_SUBST([SILK_GETOPT_HEADER_NAME])
    SILK_GETOPT_HEADER_NAME='"gnu_getopt.h"'

    AC_CHECK_HEADER([getopt.h],[
        AC_CHECK_FUNCS([getopt_long_only],[
            SILK_GETOPT_HEADER_NAME='<getopt.h>'
        ])])
])# SILK_AC_CHECK_GETOPT


# include the definition of AX_CHECK_ALIGNED_ACCESS_REQUIRED()
m4_include([autoconf/ax_check_aligned_access_required.m4])

# ---------------------------------------------------------------------------
# SILK_AC_COMPILER
#
#    Set the compiler and compilation flags
#
AC_DEFUN([SILK_AC_COMPILER],[
    AM_PROG_CC_C_O
    AC_PROG_CPP

    AC_SUBST(SK_CPPFLAGS)
    AC_SUBST(SK_CFLAGS)
    AC_SUBST(WARN_CFLAGS)
    AC_SUBST(SK_LDFLAGS)
    AC_SUBST(IS_LITTLE_ENDIAN)
    AC_SUBST(IS_BIG_ENDIAN)

    SK_CPPFLAGS='-I$(top_srcdir)/src/include -DNDEBUG'

    # Add platform specific linking flags
    case $build_os in
        # The following allows 2GB address space.
        aix*) SK_LDFLAGS="$SK_LDFLAGS -Wl,-bmaxdata:0x80000000" ;;
    esac

    # Make compiler adjustments
    SILK_AC_OPT_DISABLE_OPTIMIZATION
    SILK_AC_OPT_ENABLE_DEBUGGING

    # Potentially remove -DNDEBUG from SK_CPPFLAGS
    SILK_AC_OPT_ENABLE_ASSERT

    # Add additional compiler flags to SK_CFLAGS
    SILK_AC_COMP_ADDITIONAL_FLAGS([SK_CFLAGS],[-fno-strict-aliasing])
    SILK_AC_OPT_ENABLE_GCOV
    SILK_AC_OPT_ENABLE_GPROF

    # Add warning flags to WARN_CFLAGS
    SILK_AC_OPT_DISABLE_WARNINGS
    SILK_AC_OPT_ENABLE_EXTRA_WARNINGS

    # Additional characteristics
    AC_C_CONST
    AC_C_INLINE
    AC_C_VOLATILE
    SILK_AC_COMP_ATTRIBUTE_USED

    AC_C_BIGENDIAN()
    val=`awk '/^# *define[ \t]+WORDS_BIGENDIAN[ \t]/ { print $NF; exit; }' confdefs.h`
    if test "x$val" = "x1"
    then
        IS_LITTLE_ENDIAN=0
        IS_BIG_ENDIAN=1
    else
        IS_LITTLE_ENDIAN=1
        IS_BIG_ENDIAN=0
    fi

    AX_CHECK_ALIGNED_ACCESS_REQUIRED

])#SILK_AC_COMPILER


# ---------------------------------------------------------------------------
# SILK_AC_COMP_ADDITIONAL_FLAGS(var, flag_list)
#
#    For each flag listed in FLAG_LIST, add it to the specified VAR if
#    the compiler understands it.
#
AC_DEFUN([SILK_AC_COMP_ADDITIONAL_FLAGS],[
    AC_LANG_CONFTEST([[
        int main(int argc, char **argv) { int x = 0; if (argv[argc-1]) { ++x; } return 0; } ]])

    for sk_cc_flag in $2
    do
        AC_MSG_CHECKING([whether ${CC-cc} understands $sk_cc_flag])
        sk_cc_cmd="${CC-cc} $sk_cc_flag -c conftest.c"
        sk_cc_out="`$sk_cc_cmd 2>&1`"
        if test "X$sk_cc_out" = X
        then
            $1="$$1 $sk_cc_flag"
            AC_MSG_RESULT([yes])
        else
            AC_MSG_RESULT([no])
            echo "$as_me:$LINENO: failed command was" >&5
            echo "$as_me:$LINENO: $sk_cc_cmd" >&5
            echo "$as_me:$LINENO: $sk_cc_out" >&5
        fi
    done
])#SILK_AC_COMP_ADDITIONAL_FLAGS


# ---------------------------------------------------------------------------
# SILK_AC_COMP_ATTRIBUTE_USED
#
#    Check whether the compile understands the __attribute__((__used__))
#
AC_DEFUN([SILK_AC_COMP_ATTRIBUTE_USED],
    [AC_MSG_CHECKING([whether the compiler understands __attribute__((__used__))])

    # Don't use AC_LANG_WERROR since it applies to *ALL* configure
    # tests and there is no way to disable it once enabled, nor a way
    # to enable it only for this test.

    sk_save_CFLAGS="$CFLAGS"
    CFLAGS="-Werror $CFLAGS"

    AC_COMPILE_IFELSE(
        [AC_LANG_PROGRAM([],[
             static char *x __attribute__((__used__)) = "used";
             ])
        ],[
            AC_DEFINE([HAVE_COMP_ATTRIBUTE_USED],[1],
                [Define to 1 if your compiler understands __attribute__((__used__)).])
            AC_MSG_RESULT([yes])],
        [AC_MSG_RESULT([no])])

    CFLAGS="$sk_save_CFLAGS"
])# SILK_AC_COMP_ATTRIBUTE_USED


# ---------------------------------------------------------------------------
# SILK_AC_COMP_INCLUDE_TO_CFLAG
#
#    Some defines really need to be set before any header files are
#    read, but this creates a problem for C files generated by YACC
#    and LEX.
#
#    So, for defines that the system headers use, grep their values
#    out of the confdefs.h file and add them to CPPFLAGS.
#
AC_DEFUN([SILK_AC_COMP_INCLUDE_TO_CFLAG],[
    for sk_defined in _ALL_SOURCE _GNU_SOURCE _FILE_OFFSET_BITS _LARGEFILE_SOURCE _LARGE_FILES _REENTRANT
    do
        sk_def_test=`echo $sk_defined | sed -e 's/,.*$//'`
        sk_def_flag=`echo $sk_defined | sed -e 's/^.*,//'`

        val=`awk '/^# *define[ \t]+'$sk_def_test'[ \t]/ { print $NF; exit; }' confdefs.h`
        if test "X$val" != X
        then
            SK_CPPFLAGS="$SK_CPPFLAGS -D$sk_def_flag=$val"
        fi
    done
])# SILK_AC_COMP_INCLUDE_TO_CFLAG


# ---------------------------------------------------------------------------
# SILK_AC_COMP_SHARED_OBJECT
#
#    Set variables for building shared objects (dynamic libraries)
#
AC_DEFUN([SILK_AC_COMP_SHARED_OBJECT],[
    AC_SUBST(SHLIB_EXT)
    AC_SUBST(SHLIB_LD)
    AC_SUBST(SHLIB_LDFLAGS)
    AC_SUBST(SHLIB_LIBS)
    AC_SUBST(SHLIB_CCFLAGS)
    AC_SUBST(USES_DLOPEN_FLAGS)

    AC_MSG_NOTICE([(${PACKAGE}) Determining settings for shared object support])

    AC_MSG_CHECKING([standard extension (SHLIB_EXT)])
    if test -z "$SHLIB_EXT"
    then
        SHLIB_EXT=so
        #case $build_os in
        #esac
    fi
    AC_MSG_RESULT($SHLIB_EXT)


    AC_MSG_CHECKING([for compile-time flags (SHLIB_CCFLAGS)])
    if test -z "$SHLIB_CCFLAGS"
    then
        SHLIB_CCFLAGS="-DPIC -fPIC"
        case $build_os in
            aix*)       SHLIB_CCFLAGS="" ;;
            osf*)       SHLIB_CCFLAGS="" ;;
        esac
    fi
    if test -n "$SHLIB_CCFLAGS"
    then
        AC_MSG_RESULT($SHLIB_CCFLAGS)
    else
        AC_MSG_RESULT([(none required)])
    fi


    AC_MSG_CHECKING([for link command (SHLIB_LD)])
    if test -z "$SHLIB_LD"
    then
        # Use CC normally, but use LD on some platforms
        SHLIB_LD='$(CC)'
        case $build_os in
            aix*)       SHLIB_LD='$(LD)' ;;
            osf*)       SHLIB_LD='$(LD)' ;;
        esac
    fi
    AC_MSG_RESULT($SHLIB_LD)


    AC_MSG_CHECKING([the link-time flags (SHLIB_LDFLAGS)])
    if test -z "$SHLIB_LDFLAGS"
    then
        SHLIB_LDFLAGS='$(SHLIB_CCFLAGS) -shared'
        case $build_os in
            aix*)       SHLIB_LDFLAGS="-G -bnoentry -bexpall -b32 -bM:SRE -bmaxdata:0x80000000" ;;
            darwin*)    SHLIB_LDFLAGS="-bundle -flat_namespace -undefined suppress" ;;
            osf*)       SHLIB_LDFLAGS="-shared -expect_unresolved '*'" ;;
            solaris*)   SHLIB_LDFLAGS="$SHLIB_LDFLAGS -mimpure-text" ;;
        esac
    fi
    if test -n "$SHLIB_LDFLAGS"
    then
        AC_MSG_RESULT($SHLIB_LDFLAGS)
    else
        AC_MSG_RESULT([(none required)])
    fi


    AC_MSG_CHECKING([for extra libraries (SHLIB_LIBS)])
    if test -z "$SHLIB_LIBS"
    then
        SHLIB_LIBS=
        case $build_os in
            aix*)       SHLIB_LIBS="-lc -ldl" ;;
        esac
    fi
    if test -n "$SHLIB_LIBS"
    then
        AC_MSG_RESULT($SHLIB_LIBS)
    else
        AC_MSG_RESULT([(none required)])
    fi


    AC_MSG_CHECKING([for flags to export symbols (USES_DLOPEN_FLAGS)])
    if test -z "$USES_DLOPEN_FLAGS"
    then
        USES_DLOPEN_FLAGS=""
        case $build_os in
            # The "100" on the next line is arbitrarily large.  We
            # don't want to have the linker doing gc on unreferenced
            # functions, since they may be referenced by run-time
            # dynamically-loaded libraries
            aix*)       USES_DLOPEN_FLAGS="-Wl,-brtl,-bexpall,-bgcbypass:100" ;;
            linux*)     USES_DLOPEN_FLAGS="-rdynamic" ;;
            openbsd*)   USES_DLOPEN_FLAGS="-Wl,-export-dynamic" ;;
        esac
    fi
    if test -n "$USES_DLOPEN_FLAGS"
    then
        AC_MSG_RESULT($USES_DLOPEN_FLAGS)
    else
        AC_MSG_RESULT([(none required)])
    fi

    AC_MSG_NOTICE([(${PACKAGE}) Shared object checks completed])
])#SILK_AC_COMP_SHARED_OBJECT


# ---------------------------------------------------------------------------
# SILK_AC_FIND_SITE_MAKEFILES
#
#    Find all the subdirectories to build.
#
#    Output variables: SILK_SITE_SUBDIRS
#
AC_DEFUN([SILK_AC_FIND_SITE_MAKEFILES],[
    AC_SUBST(SILK_SITE_SUBDIRS)

    # build the list of sites by a glob pattern
    m4_define([sk_site_list],
              [m4_bpatsubst(m4_esyscmd([echo site/[A-Za-z]*/Makefile.am]),
                            [Makefile\.am], [Makefile])])

    AC_CONFIG_FILES(sk_site_list)

    # create directory list
    for skdir in sk_site_list
    do
        skdir=`echo "$skdir" | sed 's,^site/\(.*\)/Makefile$,\1,'`
        SILK_SITE_SUBDIRS="$SILK_SITE_SUBDIRS $skdir"
    done
])


# ---------------------------------------------------------------------------
# SILK_AC_INIT - initialize SiLK autoconf magic
#
#    All configure.in files should start with an invocation of
#    SILK_AC_INIT
#
AC_DEFUN([SILK_AC_INIT],[
    SPLINT_FLAGS="+posixlib +unixlib -weak"
    AC_SUBST(SPLINT_FLAGS)

    PACKAGE=silk
    PACKAGENAME=silk
    PACKING_LOGIC_PATH_DEFAULT="${srcdir}/site/twoway/packlogic-twoway.c"
    SILK_DATA_ROOTDIR_DEFAULT=/data

    # Stash the current CFLAGS value
    silk_init_cflags="$CFLAGS"

    # Groups of Makefile.in's to create
    silk_enable_analysis_tools=1
    silk_enable_packing_tools=1

    # the filename extension to use for SiLK plug-ins
    AC_SUBST([SILK_PLUGIN_SUFFIX], [.so])

    # libtool flags to use when building a SiLK plugin.  We should be
    # able to include "-module" in this list, but automake complains
    # when the <plugin-name>_LDFLAGS variables in the Makefile.am
    # files appear to be empty, so we set that variable to "-module
    # $(SILK_PLUGIN_LIBTOOL_FLAGS)"
    AC_SUBST([SILK_PLUGIN_LIBTOOL_FLAGS],
             ['-avoid-version -shrext $(SILK_PLUGIN_SUFFIX)'])

    # add $(prefix)/lib/pkgconfig to PKG_CONFIG_PATH.  We should
    # really use $(libdir)/pkgconfig, but trying to get that value is
    # difficult.
    silk_extra_pkg_config="$prefix/lib/pkgconfig"
    if test "x$PKG_CONFIG_PATH" = "x"
    then
        PKG_CONFIG_PATH="$silk_extra_pkg_config"
    else
        PKG_CONFIG_PATH="$PKG_CONFIG_PATH:$silk_extra_pkg_config"
    fi
    export PKG_CONFIG_PATH

    # variables we use when creating the rpm silk.spec file
    RPM_SPEC_REQUIRES=""
    RPM_SPEC_BUILDREQUIRES="flex, bison,"
    RPM_SPEC_CONFIGURE=""
    AC_SUBST(RPM_SPEC_REQUIRES)
    AC_SUBST(RPM_SPEC_BUILDREQUIRES)
    AC_SUBST(RPM_SPEC_CONFIGURE)


])# SILK_AC_INIT


# ---------------------------------------------------------------------------
# SILK_AC_NEED_REENTRANT
#
#    Check whether -D_REENTRANT is required for certain functions
#    (Solaris)
#
#    Output definitions: SK_NEED_REENTRANT
#
AC_DEFUN([SILK_AC_NEED_REENTRANT],[
    AC_CHECK_DECL(gmtime_r, ,[
        AC_MSG_CHECKING([whether gmtime_r is declared with -D_REENTRANT])
        AC_COMPILE_IFELSE([
            AC_LANG_PROGRAM([
#define _REENTRANT 1
#include <stdio.h>
#if HAVE_SYS_TYPES_H
# include <sys/types.h>
#endif
#if     TIME_WITH_SYS_TIME
#  include <sys/time.h>
#  include <time.h>
#else
#  if   HAVE_SYS_TIME_H
#    include <sys/time.h>
#  else
#    include <time.h>
#  endif
#endif
],[
#ifndef gmtime_r
    char *p = (char *) gmtime_r;
#endif
])],[
            AC_DEFINE([_REENTRANT],[1],[Whether gmtime_r() requires _REENTRANT])
            AC_MSG_RESULT([yes])],
            [AC_MSG_RESULT([no])])
    ],[
#include <stdio.h>
#if HAVE_SYS_TYPES_H
# include <sys/types.h>
#endif
#if     TIME_WITH_SYS_TIME
#  include <sys/time.h>
#  include <time.h>
#else
#  if   HAVE_SYS_TIME_H
#    include <sys/time.h>
#  else
#    include <time.h>
#  endif
#endif
    ])
])#SILK_AC_NEED_REENTRANT


# ---------------------------------------------------------------------------
# SILK_AC_OPT_DATA_ROOTDIR
#
#    Let the user specify the base directory where the packed data
#    should be stored and from where it will be read.
#
#    Output variable: SILK_DATA_ROOTDIR
#
AC_DEFUN([SILK_AC_OPT_DATA_ROOTDIR],[
    AC_SUBST(SILK_DATA_ROOTDIR)

    AC_ARG_ENABLE([data-rootdir],
        [AS_HELP_STRING([--enable-data-rootdir=DIR],
            [location of packed data files [/data]])[]dnl
        ],[[
        if test "x$enableval" != "xyes"
        then
            SILK_DATA_ROOTDIR="$enableval"
        fi
        ]])

    if test "x${SILK_DATA_ROOTDIR}" = "x"
    then
        SILK_DATA_ROOTDIR="${SILK_DATA_ROOTDIR_DEFAULT}"
    fi
])# SILK_AC_OPT_DATA_ROOTDIR


# ---------------------------------------------------------------------------
# SILK_AC_OPT_DISABLE_ANALYSIS_TOOLS
#
#    Do not build the analysis tools
#
AC_DEFUN([SILK_AC_OPT_DISABLE_ANALYSIS_TOOLS],[
    AC_ARG_ENABLE([analysis-tools],
        [AS_HELP_STRING([--disable-analysis-tools],
            [do not descend into the analysis tools directories when building the software])[]dnl
        ],[[
        if test "x$enableval" = "xno"
        then
            silk_enable_analysis_tools=0
        fi]])

    AM_CONDITIONAL(BUILD_ANALYSIS_TOOLS,
        [test "x$silk_enable_analysis_tools" = "x1"])
]) # SILK_AC_OPT_DISABLE_ANALYSIS_TOOLS


# ---------------------------------------------------------------------------
# SILK_AC_OPT_DISABLE_OPTIMIZATION
#
#    Remove optimization from the CFLAGS; if -O2 was added by
#    AC_PROG_CC
#
AC_DEFUN([SILK_AC_OPT_DISABLE_OPTIMIZATION],[
    sk_add_o3=1
    AC_ARG_ENABLE([optimization],
        [AS_HELP_STRING([--disable-optimization],
            [disable optimization (default is to build SiLK with -O3); use --enable-optimization=VAL to set optimization to VAL])[]dnl
        ],[[
        if test "x$enableval" = "xno"
        then
            # User said "--disable-optimization".  Unconditionally
            # remove -O[0-9] from the CFLAGS.
            CFLAGS=`echo " $CFLAGS " | sed 's/ -O[0-9] / /g'`
            sk_add_o3=0
        elif test "x$enableval" != "xyes"
        then
            # User passed in their own optimation flags on this switch
            CFLAGS=`echo " $CFLAGS " | sed 's/ -O[0-9] / /g'`
            CFLAGS="$CFLAGS $enableval"
            sk_add_o3=0
        fi
        ]])
    if test "x$sk_add_o3" = "x1"
    then
        # User didn't specify the switch; if the user didn't specify
        # any CFLAGS to configure (i.e., "$silk_init_cflags" is empty)
        # remove any optimization added by AC_PROG_CC and add -O3 now
        # if the compiler understands it.
        if test "x$silk_init_cflags" = "x"
        then
            sk_add_o3=""
            SILK_AC_COMP_ADDITIONAL_FLAGS(sk_add_o3, [-O3])
            if test "xsk_add_o3" != "x"
            then
                CFLAGS=`echo " $CFLAGS " | sed 's/ -O[[0-9]] / /g'`
                CFLAGS="$CFLAGS $sk_add_o3"
            fi
        fi
    fi
])# SILK_AC_OPT_DISABLE_OPTIMIZATION


# ---------------------------------------------------------------------------
# SILK_AC_OPT_DISABLE_PACKING_TOOLS
#
#    Do not build the packing tools
#
AC_DEFUN([SILK_AC_OPT_DISABLE_PACKING_TOOLS],[
    AC_ARG_ENABLE([packing-tools],
        [AS_HELP_STRING([--disable-packing-tools],
            [do not descend into the packing tools directories when buiding the software])[]dnl
        ],[[
        if test "x$enableval" = "xno"
        then
            silk_enable_packing_tools=0
        fi]])

    AM_CONDITIONAL(BUILD_PACKING_TOOLS,
        [test "x$silk_enable_packing_tools" = "x1"])
]) # SILK_AC_OPT_DISABLE_PACKING_TOOLS


# ---------------------------------------------------------------------------
# SILK_AC_OPT_DISABLE_SPLIT_WEB
#
#    Do not pack the web flows separately
#
AC_DEFUN([SILK_AC_OPT_DISABLE_SPLIT_WEB],[
    AC_ARG_ENABLE([web-split],
        [AS_HELP_STRING([--disable-web-split],
            [in the packer, do not pack the web flows separately from other flows])[]dnl
        ],[[
        if test "x$enableval" = "xno"
        then
            silk_enable_web_split=0
        fi]])
]) # SILK_AC_OPT_DISABLE_SPLIT_WEB


# ---------------------------------------------------------------------------
# SILK_AC_OPT_DISABLE_WARNINGS
#
#    Do not add warning flags to WARN_CFLAGS.  If optional value
#    provided, add that to WARN_CFLAGS instead.
#
AC_DEFUN([SILK_AC_OPT_DISABLE_WARNINGS],[
    sk_add_warnings=1
    AC_ARG_ENABLE([warnings],
        [AS_HELP_STRING([--disable-warnings],
            [do not add CC warning flags to the default CFLAGS. If value provided, add that to the default CFLAGS])[]dnl
        ],[[
        if test "x$enableval" = "xno"
        then
            sk_add_warnings=0
        elif test "x$enableval" != "xyes"
        then
            # User provide their own warning flags
            sk_add_warnings=0
            WARN_CFLAGS="$WARN_CFLAGS $enableval"
        fi
        ]])
    if test $sk_add_warnings = 1
    then
        # User didn't specify the switch; so add the warning flags
        SILK_AC_COMP_ADDITIONAL_FLAGS([WARN_CFLAGS],[-Wall -W -Wmissing-prototypes -Wformat=2 -Wdeclaration-after-statement])
    fi
]) # SILK_AC_OPT_DISABLE_WARNINGS




# ---------------------------------------------------------------------------
# SILK_AC_OPT_ENABLE_ASSERT
#
#    Remove -DNDEBUG from the SK_CPPFLAGS to enable assert()'s
#
AC_DEFUN([SILK_AC_OPT_ENABLE_ASSERT],[
    AC_ARG_ENABLE([assert],
        [AS_HELP_STRING([--enable-assert],
            [enable run-time checks with assert()])[]dnl
        ],[[
        if test "x$enableval" = "xyes"
        then
            SK_CPPFLAGS=`echo " $SK_CPPFLAGS " | sed 's/ -DNDEBUG / /'`
        fi
        RPM_SPEC_CONFIGURE="$RPM_SPEC_CONFIGURE --enable-assert"
    ]])
])# SILK_AC_OPT_ENABLE_ASSERT


# ---------------------------------------------------------------------------
# SILK_AC_OPT_ENABLE_DEBUGGING
#
#    Add the -g switch to CFLAGS if and only if the switch is
#    provided; i.e., remove -g if the switch is not provided.
#
AC_DEFUN([SILK_AC_OPT_ENABLE_DEBUGGING],[
    # Remove -g from CFLAGS unless it was specified in the CFLAGS
    # value the passed to configure
    sk_have_g=`echo "  $silk_init_cflags " | grep '. -g '`
    if test -z "$sk_have_g"
    then
        # Remove it
        CFLAGS=`echo " $CFLAGS " | sed 's/ -g / /g'`
    fi

    AC_ARG_ENABLE([debugging],
        [AS_HELP_STRING([--enable-debugging],
            [add compiler flags to build with debugging symbols])[]dnl
        ],[[
        if test "x$enableval" != "xno"
        then
            # Add the switch
            CFLAGS="$CFLAGS -g"
        fi]])
])# SILK_AC_OPT_ENABLE_DEBUGGING


# ---------------------------------------------------------------------------
# SILK_AC_OPT_ENABLE_EXTRA_WARNINGS
#
#    Add additional warning flags to WARN_CFLAGS.  If optional value
#    provided, add that to WARN_CFLAGS instead.
#
AC_DEFUN([SILK_AC_OPT_ENABLE_EXTRA_WARNINGS],[
    sk_enable_extra_warnings=0
    AC_ARG_ENABLE([extra-warnings],
        [AS_HELP_STRING([--enable-extra-warnings],
            [add additional warning flags to the default CFLAGS. If value provided, add that to the default CFLAGS])[]dnl
        ],[[
        if test "x$enableval" = "xyes"
        then
            sk_enable_extra_warnings=1
        elif test "x$enableval" != "xno"
        then
            # User provide their own warning flags
            WARN_CFLAGS="$WARN_CFLAGS $enableval"
        fi
        ]])
    if test $sk_enable_extra_warnings = 1
    then
        SILK_AC_COMP_ADDITIONAL_FLAGS([WARN_CFLAGS],[-Wshadow -Wundef -std=c89 -pedantic -Wno-long-long])
        #  -Wconversion doesn't seem to understand integers smaller than
        #  uint32---that is, it warns about them when it shouldn't
        #SILK_AC_COMP_ADDITIONAL_FLAGS([WARN_CFLAGS],[-Wconversion])
    fi
]) # SILK_AC_OPT_ENABLE_EXTRA_WARNINGS


# ---------------------------------------------------------------------------
# SILK_AC_OPT_ENABLE_GCOV
#
#    Add the -fprofile-arcs -ftest-coverage switches to SK_CFLAGS
#    and disable optimization
#
AC_DEFUN([SILK_AC_OPT_ENABLE_GCOV],[
    AC_ARG_ENABLE([gcov],
        [AS_HELP_STRING([--enable-gcov],
            [add compiler flags to support gcov testing])[]dnl
        ],[[
        if test "x$enableval" != "xno"
        then
            CFLAGS=`echo " $CFLAGS " | sed 's/ -O[0-9] / /g'`
            SK_CFLAGS="$SK_CFLAGS -fprofile-arcs -ftest-coverage"
        fi
        ]])
])# SILK_AC_OPT_ENABLE_GCOV


# ---------------------------------------------------------------------------
# SILK_AC_OPT_ENABLE_GPROF
#
#    Add the -pg switch to SK_CFLAGS and enable debugging symbols
#
AC_DEFUN([SILK_AC_OPT_ENABLE_GPROF],[
    AC_ARG_ENABLE([gprof],
        [AS_HELP_STRING([--enable-gprof],
            [add compiler flags to support gprof profiling])[]dnl
        ],[[
        if test "x$enableval" != "xno"
        then
            CFLAGS="$CFLAGS -g"
            SK_CFLAGS="$SK_CFLAGS -pg"
        fi
        ]])
])# SILK_AC_OPT_ENABLE_GPROF


# ---------------------------------------------------------------------------
# SILK_AC_OPT_ENABLE_IPV6
#
#    Enable experimental support for IPv6 addresses.
#
#    Output variable: SK_ENABLE_IPV6
#
AC_DEFUN([SILK_AC_OPT_ENABLE_IPV6],[
    AC_SUBST([SK_ENABLE_IPV6])
    SK_ENABLE_IPV6=0

    AC_ARG_ENABLE([ipv6],
        [AS_HELP_STRING([--enable-ipv6],
            [enable support for flows containing IPv6 addresses.  This support is experimental.])[]dnl
        ],[[
        if test "x$enableval" = "xyes"
        then
            SK_ENABLE_IPV6=1
        fi]])

    if test "x$SK_ENABLE_IPV6" = "x1"
    then
        RPM_SPEC_CONFIGURE="$RPM_SPEC_CONFIGURE --enable-ipv6"
    else
        RPM_SPEC_CONFIGURE="$RPM_SPEC_CONFIGURE --disable-ipv6"
    fi
])# SILK_AC_OPT_ENABLE_IPV6


# ---------------------------------------------------------------------------
# SILK_AC_OPT_ENABLE_LOCALTIME
#
#    Use the local timezone for command inputs and printing records
#
AC_DEFUN([SILK_AC_OPT_ENABLE_LOCALTIME],[
    AC_SUBST([SK_ENABLE_LOCALTIME])
    SK_ENABLE_LOCALTIME=0

    AC_ARG_ENABLE([localtime],
        [AS_HELP_STRING([--enable-localtime],
            [use the local timezone for command inputs and for printing records.  Default is to use UTC.  (Files continue to be stored by UTC time).])[]dnl
        ],[[
        if test "x$enableval" = "xyes"
        then
            SK_ENABLE_LOCALTIME=1
        fi]])

    if test "x$SK_ENABLE_LOCALTIME" = "x1"
    then
        RPM_SPEC_CONFIGURE="$RPM_SPEC_CONFIGURE --enable-localtime"
    fi
])# SILK_AC_OPT_ENABLE_LOCALTIME




# ---------------------------------------------------------------------------
# SILK_AC_OPT_ENABLE_OUTPUT_COMPRESSION
#
#    Set the default compression method to use for binary output files.
#
#    Output variables: SK_ENABLE_OUTPUT_COMPRESSION
#
AC_DEFUN([SILK_AC_OPT_ENABLE_OUTPUT_COMPRESSION],[
    AC_SUBST([SK_ENABLE_OUTPUT_COMPRESSION])

    # The default compression method
    sk_output_comp=none

    AC_ARG_ENABLE([output-compression],
        [AS_HELP_STRING([--enable-output-compression],
            [enable or set the default compression method for binary SiLK output files. Choices (subject to library availability): none, zlib, lzo1x. [none]])[]dnl
        ],[[sk_output_comp="$enableval"]])

    case "$sk_output_comp" in
        yes)
            # use the best we can find
            sk_output_comp=none
            if test "x$SK_ENABLE_ZLIB" = "x1"
            then
                sk_output_comp=zlib
            fi
            if test "x$SK_ENABLE_LZO" = "x1"
            then
                sk_output_comp=lzo1x
            fi
            ;;
        no|none)
            sk_output_comp=none
            ;;
        zlib)
            if test "x$SK_ENABLE_ZLIB" != "x1"
            then
                AC_MSG_ERROR([output-compression=$sk_output_comp is not available because zlib was not found])
            fi
            ;;
        lzo1x)
            if test "x$SK_ENABLE_LZO" != "x1"
            then
                AC_MSG_ERROR([output-compression=$sk_output_comp is not available because LZO was not found])
            fi
            ;;
        *)
            AC_MSG_ERROR([output-compression=$sk_output_comp is not valid])
            ;;
    esac

    # Be certain to keep this list up-to-date with the C code in
    # silk_files.h and sksite.[ch]
    SK_ENABLE_OUTPUT_COMPRESSION='SK_COMPMETHOD_'`echo $sk_output_comp | tr '[[a-z]]' '[[A-Z]]'`
    AC_MSG_NOTICE([(${PACKAGE}) Default output compression is $sk_output_comp])

    RPM_SPEC_CONFIGURE="$RPM_SPEC_CONFIGURE --enable-output-compression=$sk_output_comp"
])# SILK_AC_OPT_ENABLE_OUTPUT_COMPRESSION


# ---------------------------------------------------------------------------
# SILK_AC_OPT_ENABLE_PACKING_LOGIC
#
#   Allow the use of a static C file to determine the packing logic
#
#   Output variables: PACKING_LOGIC_PATH
#   Defines: SK_PACKING_LOGIC_PATH
#
AC_DEFUN([SILK_AC_OPT_ENABLE_PACKING_LOGIC],[
    AC_SUBST(PACKING_LOGIC_PATH)

    sk_pack_path=

    AC_ARG_ENABLE([packing-logic],
        AS_HELP_STRING([--enable-packing-logic=PATH],
            [configure the packer (rwflowpack) to statically include PATH for the packing logic. When not provided, rwflowpack uses a run-time plug-in to determine the packing logic]),
        [
            if test "x$enableval" != "xno"
            then
                sk_pack_path="$enableval"
            fi
        ])

    # Can't do plug-ins if the user has disabled shared libraries
    if test "x$sk_pack_path" = "x"
    then
        if test "x$enable_shared" = xno || test "x$STATIC_APPLICATIONS" != "x"
        then
            sk_pack_path="$PACKING_LOGIC_PATH_DEFAULT"
            AC_MSG_NOTICE([(${PACKAGE}) Using static packing logic because of static linking])
        fi
    fi

    if test "x$sk_pack_path" != "x"
    then
        # If the path is relative, add the current directory to it
        case "X$sk_pack_path" in
          X/*) PACKING_LOGIC_PATH="$sk_pack_path" ;;
          *)   PACKING_LOGIC_PATH="`pwd`/$sk_pack_path" ;;
        esac

        # See if we can find the file
        AC_CHECK_FILE([$PACKING_LOGIC_PATH], ,
            AC_MSG_ERROR([Cannot find site packing logic file $PACKING_LOGIC_PATH]))

        AC_DEFINE_UNQUOTED([SK_PACKING_LOGIC_PATH], "$PACKING_LOGIC_PATH",
            [Define to the path of the C source file that rwflowpack will use for categorizing flow records.  When this is undefined, rwflowpack will use a plug-in loaded at run-time to determine the categories.])

    fi

    AM_CONDITIONAL(HAVE_PACKING_LOGIC, [test "x$sk_pack_path" != "x"])
])# SILK_AC_OPT_ENABLE_PACKING_LOGIC


# ---------------------------------------------------------------------------
# SILK_AC_OPT_ENABLE_SPLIT_ICMP
#
#    Do not pack the web flows separately
#
AC_DEFUN([SILK_AC_OPT_ENABLE_SPLIT_ICMP],[
    AC_ARG_ENABLE([icmp-split],
        [AS_HELP_STRING([--enable-icmp-split],
            [in the packer, pack ICMP flow records separately from other flows])[]dnl
        ],[[
        if test "x$enableval" != "xno"
        then
            silk_enable_icmp_split=1
        fi]])
]) # SILK_AC_OPT_ENABLE_SPLIT_ICMP


# ---------------------------------------------------------------------------
# SILK_AC_OPT_ENABLE_STATIC_APPLICATIONS
#
#    Build all applications with static linking.
#
#    Output variables: STATIC_APPLICATIONS
#
AC_DEFUN([SILK_AC_OPT_ENABLE_STATIC_APPLICATIONS],[
    AC_SUBST(STATIC_APPLICATIONS)
    AC_ARG_ENABLE([static-applications],
        [AS_HELP_STRING([--enable-static-applications],
            [use only static libraries when linking applications [[no]]])[]dnl
        ],[[
        if test "x$enableval" != "xno"
        then
            STATIC_APPLICATIONS=-static
        fi]])

    AM_CONDITIONAL(HAVE_STATIC_APPLICATIONS, [test "x$STATIC_APPLICATIONS" != "x"])
]) # SILK_AC_OPT_ENABLE_STATIC_APPLICATIONS


# ---------------------------------------------------------------------------
# SILK_AC_OPT_WITH_FIXBUF
#
#    Determine how to use libfixbuf, and whether libfixbuf supports
#    NetFlow v9
#
#    Output variables:  FIXBUF_CFLAGS, FIXBUF_LDFLAGS,
#                       SK_ENABLE_IPFIX,  SK_ENABLE_NETFLOW9
#
AC_DEFUN([SILK_AC_OPT_WITH_FIXBUF],[
    AC_SUBST(FIXBUF_CFLAGS)
    AC_SUBST(FIXBUF_LDFLAGS)
    AC_SUBST(SK_ENABLE_IPFIX)
    AC_SUBST(SK_ENABLE_NETFLOW9)
    SK_ENABLE_IPFIX=0
    SK_ENABLE_NETFLOW9=0

    silk_require_fixbuf_version=0.7.2

    m4_ifdef([PKG_CHECK_MODULES], [SILK_AC_OPT_WITH_FIXBUF_PKGCONFIG])

    if test "x$SK_ENABLE_IPFIX" = "x1"
    then
        # Cache current values
        sk_save_LDFLAGS="$LDFLAGS"
        sk_save_LIBS="$LIBS"
        sk_save_CFLAGS="$CFLAGS"
        sk_save_CPPFLAGS="$CPPFLAGS"

        FIXBUF_LDFLAGS="$LIBFIXBUF_LIBS"
        LIBS="$FIXBUF_LDFLAGS $LIBS"

        FIXBUF_CFLAGS="$LIBFIXBUF_CFLAGS"
        CFLAGS="$FIXBUF_CFLAGS $CFLAGS"

        AC_MSG_CHECKING([usability of libfixbuf library and headers])
        AC_LINK_IFELSE(
            [AC_LANG_PROGRAM([
#include <fixbuf/public.h>
                ],[
fbInfoModel_t *m = fbInfoModelAlloc();
                 ])],[
            AC_MSG_RESULT([yes])
            SK_ENABLE_IPFIX=1
            ],[
            AC_MSG_RESULT([no])
            SK_ENABLE_IPFIX=0])

        if test "x$SK_ENABLE_IPFIX" = "x1"
        then
            AC_MSG_CHECKING([whether libfixbuf supports NetFlow v9])
            AC_LINK_IFELSE(
                [AC_LANG_PROGRAM([
#include <fixbuf/public.h>
                    ],[
fbCollector_t *collector = NULL;
GError *err = NULL;
fbCollectorSetNetflowV9Translator(collector, &err);
                     ])],[
                AC_MSG_RESULT([yes])
                SK_ENABLE_NETFLOW9=1
                ],[
                AC_MSG_RESULT([no])
                SK_ENABLE_NETFLOW9=0])
        fi

        # Restore cached values
        LDFLAGS="$sk_save_LDFLAGS"
        LIBS="$sk_save_LIBS"
        CFLAGS="$sk_save_CFLAGS"
        CPPFLAGS="$sk_save_CPPFLAGS"
    fi

    if test "x$SK_ENABLE_IPFIX" = "x0"
    then
        FIXBUF_LDFLAGS=
        FIXBUF_CFLAGS=
        RPM_SPEC_CONFIGURE="$RPM_SPEC_CONFIGURE --without-libfixbuf"
    else
        RPM_SPEC_REQUIRES="$RPM_SPEC_REQUIRES libfixbuf >= $silk_require_fixbuf_version,"
        RPM_SPEC_BUILDREQUIRES="$RPM_SPEC_BUILDREQUIRES libfixbuf-devel >= $silk_require_fixbuf_version,"
    fi

    AM_CONDITIONAL(HAVE_FIXBUF, [test "x$SK_ENABLE_IPFIX" = "x1"])

])# SILK_AC_OPT_WITH_FIXBUF


# ---------------------------------------------------------------------------
# SILK_AC_OPT_WITH_FIXBUF_PKGCONFIG
#
#    Run the part of --with-fixbuf that requires pkgconfig
#
AC_DEFUN([SILK_AC_OPT_WITH_FIXBUF_PKGCONFIG],[
    sk_pkg_config=""
    AC_ARG_WITH([libfixbuf],[AS_HELP_STRING([--with-libfixbuf=DIR],
            [find libfixbuf package configuration file (libfixbuf.pc) in the directory DIR (prepends DIR to the PKG_CONFIG_PATH)])[]dnl
        ],[
            if test "x$withval" != "xyes"
            then
                sk_pkg_config="$withval"
            fi
    ])

    if test "x$sk_pkg_config" != "xno"
    then
        if test "x$sk_pkg_config" != "x"
        then
            sk_save_PKG_CONFIG_PATH="$PKG_CONFIG_PATH"
            PKG_CONFIG_PATH="$sk_pkg_config:$PKG_CONFIG_PATH"
            export PKG_CONFIG_PATH
        fi

        PKG_CHECK_MODULES([LIBFIXBUF], [libfixbuf >= $silk_require_fixbuf_version], [SK_ENABLE_IPFIX=1], [SK_ENABLE_IPFIX=0])

        if test "x$sk_pkg_config" != "x"
        then
            PKG_CONFIG_PATH="$sk_save_PKG_CONFIG_PATH"
            export PKG_CONFIG_PATH
        fi
    fi
])# SILK_AC_OPT_WITH_FIXBUF_PKGCONFIG


# ---------------------------------------------------------------------------
# SILK_AC_OPT_WITH_GNUTLS
#
#    Determine how to use GNUTLS.
#
#    Output variables:  GNUTLS_CFLAGS, GNUTLS_LDFLAGS, SK_ENABLE_GNUTLS
#
AC_DEFUN([SILK_AC_OPT_WITH_GNUTLS],[
    AC_SUBST(GNUTLS_CFLAGS)
    AC_SUBST(GNUTLS_LDFLAGS)
    AC_SUBST(SK_ENABLE_GNUTLS)
    SK_ENABLE_GNUTLS=0

    m4_ifdef([PKG_CHECK_MODULES], [SILK_AC_OPT_WITH_GNUTLS_PKGCONFIG])

    if test "x$SK_ENABLE_GNUTLS" = "x1"
    then
        # Cache current values
        sk_save_LDFLAGS="$LDFLAGS"
        sk_save_LIBS="$LIBS"
        sk_save_CFLAGS="$CFLAGS"
        sk_save_CPPFLAGS="$CPPFLAGS"

        GNUTLS_LDFLAGS="$GNUTLS_LIBS"
        LIBS="$GNUTLS_LDFLAGS $LIBS"

        CFLAGS="$GNUTLS_CFLAGS $CFLAGS"

        AC_MSG_CHECKING([usability of gnutls library and headers])
        AC_LINK_IFELSE(
                [AC_LANG_PROGRAM([
#include <stdlib.h>
#include <gnutls/gnutls.h>
#include <gcrypt.h>
#ifdef HAVE_PTHREAD_H
#include <pthread.h>
#endif
#ifdef HAVE_ERRNO_H
#include <errno.h>
#endif

gnutls_certificate_credentials_t cred;
GCRY_THREAD_OPTION_PTHREAD_IMPL;
                    ],[
gcry_control (GCRYCTL_SET_THREAD_CBS, &gcry_threads_pthread);
gnutls_global_init();
                     ])],[
                AC_MSG_RESULT([yes])
                SK_ENABLE_GNUTLS=1
                ],[
                AC_MSG_RESULT([no])
                SK_ENABLE_GNUTLS=0])

        # Restore cached values
        LDFLAGS="$sk_save_LDFLAGS"
        LIBS="$sk_save_LIBS"
        CFLAGS="$sk_save_CFLAGS"
        CPPFLAGS="$sk_save_CPPFLAGS"
    fi

    if test "x$SK_ENABLE_GNUTLS" = "x0"
    then
        GNUTLS_LDFLAGS=
        GNUTLS_CFLAGS=
        RPM_SPEC_CONFIGURE="$RPM_SPEC_CONFIGURE --without-gnutls"
    else
        RPM_SPEC_REQUIRES="$RPM_SPEC_REQUIRES gnutls,"
        RPM_SPEC_BUILDREQUIRES="$RPM_SPEC_BUILDREQUIRES gnutls-devel,"
    fi
])# SILK_AC_OPT_WITH_GNUTLS


# ---------------------------------------------------------------------------
# SILK_AC_OPT_WITH_GNUTLS_PKGCONFIG
#
#    Run the part of --with-gnutls that requires pkgconfig
#
AC_DEFUN([SILK_AC_OPT_WITH_GNUTLS_PKGCONFIG],[
    sk_pkg_config=""
    AC_ARG_WITH([gnutls],[AS_HELP_STRING([--with-gnutls=DIR],
            [find the gnutls package configuration file (gnutls.pc) in the directory DIR (prepends DIR to the PKG_CONFIG_PATH)])[]dnl
        ],[
            if test "x$withval" != "xyes"
            then
                sk_pkg_config="$withval"
            fi
    ])

    if test "x$sk_pkg_config" != "xno"
    then
        if test "x$sk_pkg_config" != "x"
        then
            sk_save_PKG_CONFIG_PATH="$PKG_CONFIG_PATH"
            PKG_CONFIG_PATH="$sk_pkg_config:$PKG_CONFIG_PATH"
            export PKG_CONFIG_PATH
        fi

        PKG_CHECK_MODULES([GNUTLS], [gnutls >= 1.4.1], [SK_ENABLE_GNUTLS=1], [SK_ENABLE_GNUTLS=0])

        if test "x$sk_pkg_config" != "x"
        then
            PKG_CONFIG_PATH="$sk_save_PKG_CONFIG_PATH"
            export PKG_CONFIG_PATH
        fi
    fi
])# SILK_AC_OPT_WITH_GNUTLS_PKGCONFIG


# ---------------------------------------------------------------------------
# SILK_AC_OPT_WITH_IPA
#
#    Determine how to use IPA
#
#    Output variables: LIBIPA_CFLAGS, LIBIPA_LDFLAGS
#    Output definitions: SK_ENABLE_IPA
#
AC_DEFUN([SILK_AC_OPT_WITH_IPA],[
    AC_SUBST([LIBIPA_CFLAGS])
    AC_SUBST([LIBIPA_LDFLAGS])
    AC_SUBST([SK_ENABLE_IPA])
    SK_ENABLE_IPA=0

    silk_require_ipa_version=0.3.0

    m4_ifdef([PKG_CHECK_MODULES], [SILK_AC_OPT_WITH_IPA_PKGCONFIG])

    if test "x$SK_ENABLE_IPA" = "x1"
    then
        # Cache current values
        sk_save_LDFLAGS="$LDFLAGS"
        sk_save_LIBS="$LIBS"
        sk_save_CFLAGS="$CFLAGS"
        sk_save_CPPFLAGS="$CPPFLAGS"

        LIBIPA_LDFLAGS="$LIBIPA_LIBS"
        LIBS="$LIBIPA_LDFLAGS $LIBS"

        CFLAGS="$LIBIPA_CFLAGS $CFLAGS"

        AC_MSG_CHECKING([usability of libipa library and headers])
        AC_LINK_IFELSE(
            [AC_LANG_PROGRAM([
#include <ipa/ipa.h>
                ],[
IPAContext *ctx;
                 ])],[
            AC_MSG_RESULT([yes])
            SK_ENABLE_IPA=1
            ],[
            AC_MSG_RESULT([no])
            SK_ENABLE_IPA=0])

        # Restore cached values
        LDFLAGS="$sk_save_LDFLAGS"
        LIBS="$sk_save_LIBS"
        CFLAGS="$sk_save_CFLAGS"
        CPPFLAGS="$sk_save_CPPFLAGS"
    fi

    if test "x$SK_ENABLE_IPA" = "x0"
    then
        LIBIPA_LDFLAGS=
        LIBIPA_CFLAGS=
        RPM_SPEC_CONFIGURE="$RPM_SPEC_CONFIGURE --without-libipa"
    else
        RPM_SPEC_REQUIRES="$RPM_SPEC_REQUIRES libipa >= $silk_require_ipa_version,"
        RPM_SPEC_BUILDREQUIRES="$RPM_SPEC_BUILDREQUIRES libipa-devel >= $silk_require_ipa_version,"
    fi

    AM_CONDITIONAL(HAVE_IPA, [test "x$SK_ENABLE_IPA" = "x1"])

])# SILK_AC_OPT_WITH_IPA


# ---------------------------------------------------------------------------
# SILK_AC_OPT_WITH_IPA_PKGCONFIG
#
#    Run the part of --with-ipa that requires pkgconfig
#
AC_DEFUN([SILK_AC_OPT_WITH_IPA_PKGCONFIG],[
    sk_pkg_config=""
    AC_ARG_WITH([libipa],[AS_HELP_STRING([--with-libipa=DIR],
            [find libipa package configuration file (libipa.pc) in the directory DIR (prepends DIR to the PKG_CONFIG_PATH)])[]dnl
        ],[
            if test "x$withval" != "xyes"
            then
                sk_pkg_config="$withval"
            fi
    ])

    if test "x$sk_pkg_config" != "xno"
    then
        if test "x$sk_pkg_config" != "x"
        then
            sk_save_PKG_CONFIG_PATH="$PKG_CONFIG_PATH"
            PKG_CONFIG_PATH="$sk_pkg_config:$PKG_CONFIG_PATH"
            export PKG_CONFIG_PATH
        fi

        PKG_CHECK_MODULES([LIBIPA], [libipa >= $silk_require_ipa_version], [SK_ENABLE_IPA=1], [SK_ENABLE_IPA=0])

        if test "x$sk_pkg_config" != "x"
        then
            PKG_CONFIG_PATH="$sk_save_PKG_CONFIG_PATH"
            export PKG_CONFIG_PATH
        fi
    fi
])# SILK_AC_OPT_WITH_IPA_PKGCONFIG


# ---------------------------------------------------------------------------
# SILK_AC_OPT_WITH_LZO
#
#    Try to find the lzo library.
#
#    Version 2 of LZO (released May-2005) puts the headers into an
#    "lzo" subdirectory (DarwinPorts uses an lzo2 subdirectory) while
#    version 1 did not.
#
#    Output defines: SK_ENABLE_LZO
#    Conditionals: HAVE_LZO
#
AC_DEFUN([SILK_AC_OPT_WITH_LZO],[
    AC_SUBST([SK_ENABLE_LZO])
    SK_ENABLE_LZO=0

    lzo_header_names="lzo2/lzo1x.h lzo/lzo1x.h lzo1x.h"
    lzo_library_names="lzo2 lzo"

    AC_ARG_WITH([lzo],
        AS_HELP_STRING([--with-lzo=LZO_DIR],
            [find lzo2/lzo1x.h, lzo/lzo1x.h, or lzo1x.h in LZO_DIR/include; find liblzo2 or liblzo in LZO_DIR/lib]),
        [
            if test "x$withval" != "xyes"
            then
                lzo_dir="$withval"
                lzo_includes="$lzo_dir/include"
                lzo_libraries="$lzo_dir/lib"
            fi
    ])
    AC_ARG_WITH([lzo-includes],[AS_HELP_STRING([--with-lzo-includes=DIR],
            [find lzo1x.h in DIR (overrides LZO_DIR/include and disables searching lzo2 and lzo subdirectories)])[]dnl
        ],[
            if test "x$withval" = "xno"
            then
                lzo_dir=no
            elif test "x$withval" != "xyes"
            then
                lzo_includes="$withval"
                lzo_header_names="lzo1x.h"
            fi
    ])
    AC_ARG_WITH([lzo-libraries],[AS_HELP_STRING([--with-lzo-libraries=DIR],
            [find liblzo2 or liblzo in DIR (overrides LZO_DIR/lib)])[]dnl
        ],[
            if test "x$withval" = "xno"
            then
                lzo_dir=no
            elif test "x$withval" != "xyes"
            then
                lzo_libraries="$withval"
            fi
    ])

    SK_ENABLE_LZO=0
    if test "x$lzo_dir" != "xno"
    then
        # Cache current values
        sk_save_LDFLAGS="$LDFLAGS"
        sk_save_LIBS="$LIBS"
        sk_save_CFLAGS="$CFLAGS"
        sk_save_CPPFLAGS="$CPPFLAGS"

        if test "x$lzo_includes" != "x"
        then
            LZO_CFLAGS="-I$lzo_includes"
            CPPFLAGS="$LZO_CFLAGS $CPPFLAGS"
        fi

        for sk_lzo_hdr in $lzo_header_names
        do
            AC_CHECK_HEADER([$sk_lzo_hdr], [
                sk_lzo_hdr="<$sk_lzo_hdr>"
                SK_ENABLE_LZO=1
                break])
        done

        if test "x$SK_ENABLE_LZO" = "x1"
        then
            #AC_MSG_CHECKING([for version of lzo])
            AC_PREPROC_IFELSE([AC_LANG_PROGRAM([[
#include $sk_lzo_hdr
#if LZO_VERSION < 0x2000
#  error "version 1"
#endif
]])],
               , [lzo_library_names="lzo"])

            SK_ENABLE_LZO=0

            # Loop over the library names
            for lzo_lib in $lzo_library_names
            do
                if test "x$lzo_libraries" = "x"
                then
                    LZO_LDFLAGS="-l$lzo_lib"
                else
                    LZO_LDFLAGS="-L$lzo_libraries -l$lzo_lib"
                fi

                AC_CHECK_LIB([$lzo_lib], [lzo1_compress],
                    [SK_ENABLE_LZO=1 ; break], , [$LZO_LDFLAGS])
            done
        fi

        if test "x$SK_ENABLE_LZO" = "x1"
        then
            LIBS="$LZO_LDFLAGS $LIBS"
            AC_MSG_CHECKING([usability of lzo library and headers])
            AC_LINK_IFELSE([
                AC_LANG_PROGRAM([
#include $sk_lzo_hdr
                ],[
lzo1_compress ();
                ])], [AC_MSG_RESULT([yes])], [
                    AC_MSG_RESULT([no])
                    SK_ENABLE_LZO=0])
        fi

        # Restore cached values
        LDFLAGS="$sk_save_LDFLAGS"
        LIBS="$sk_save_LIBS"
        CFLAGS="$sk_save_CFLAGS"
        CPPFLAGS="$sk_save_CPPFLAGS"
    fi

    if test "x$SK_ENABLE_LZO" != "x1"
    then
        RPM_SPEC_CONFIGURE="$RPM_SPEC_CONFIGURE --without-lzo"
    else
        SK_CPPFLAGS="$SK_CPPFLAGS $LZO_CFLAGS"
        SK_LIBS="$LZO_LDFLAGS $SK_LIBS"
        SK_BASIC_HEADERS="$SK_BASIC_HEADERS $sk_lzo_hdr"
        RPM_SPEC_REQUIRES="$RPM_SPEC_REQUIRES lzo,"
        RPM_SPEC_BUILDREQUIRES="$RPM_SPEC_BUILDREQUIRES lzo-devel,"
    fi

    AM_CONDITIONAL(HAVE_LZO,  [test "x$SK_ENABLE_LZO" = x1])

])# SILK_AC_OPT_WITH_LZO




# ---------------------------------------------------------------------------
# SILK_AC_OPT_WITH_PCAP
#
#    Determine how to use pcap.  Output variable: PCAP_LDFLAGS
#    Output definition: HAVE_PCAP_H
#
AC_DEFUN([SILK_AC_OPT_WITH_PCAP],[
    AC_SUBST(PCAP_LDFLAGS)

    AC_ARG_WITH([pcap],[AS_HELP_STRING([--with-pcap=PCAP_DIR],
            [find pcap.h in PCAP_DIR/include, libpcap in PCAP_DIR/lib])[]dnl
        ],[
            if test "x$withval" != "xyes"
            then
                pcap_dir="$withval"
                pcap_includes="$pcap_dir/include"
                pcap_libraries="$pcap_dir/lib"
            fi
    ])
    AC_ARG_WITH([pcap-includes],[AS_HELP_STRING([--with-pcap-includes=DIR],
            [find pcap.h in DIR (overrides PCAP_DIR/include)])[]dnl
        ],[
            if test "x$withval" = "xno"
            then
                pcap_dir=no
            elif test "x$withval" != "xyes"
            then
                pcap_includes="$withval"
            fi
    ])
    AC_ARG_WITH([pcap-libraries],[AS_HELP_STRING([--with-pcap-libraries=DIR],
            [find libpcap in DIR (overrides PCAP_DIR/lib)])[]dnl
        ],[
            if test "x$withval" = "xno"
            then
                pcap_dir=no
            elif test "x$withval" != "xyes"
            then
                pcap_libraries="$withval"
            fi
    ])

    SK_ENABLE_PCAP=0
    if test "x$pcap_dir" != "xno"
    then
        # Cache current values
        sk_save_LDFLAGS="$LDFLAGS"
        sk_save_LIBS="$LIBS"
        sk_save_CFLAGS="$CFLAGS"
        sk_save_CPPFLAGS="$CPPFLAGS"

        PCAP_LDFLAGS="-lpcap"
        if test "x$pcap_libraries" != "x"
        then
            PCAP_LDFLAGS="-L$pcap_libraries $PCAP_LDFLAGS"
        fi
        LIBS="$PCAP_LDFLAGS $LIBS"

        if test "x$pcap_includes" != "x"
        then
            PCAP_CFLAGS="-I$pcap_includes"
            CPPFLAGS="$PCAP_CFLAGS $CPPFLAGS"
        fi

        AC_CHECK_HEADER([pcap.h], [SK_ENABLE_PCAP=1])

        if test "x$SK_ENABLE_PCAP" = "x1"
        then
            AC_CHECK_LIB([pcap], [pcap_open_dead], [], [SK_ENABLE_PCAP=0])
        fi

        if test "x$SK_ENABLE_PCAP" = "x1"
        then
            AC_MSG_CHECKING([usability of PCAP library and headers])
            AC_LINK_IFELSE(
                [AC_LANG_PROGRAM([
#include <pcap.h>
                    ],[
pcap_t *pc;
u_char *pkt;
struct pcap_pkthdr hdr;
pcap_dumper_t *dump;

pc = pcap_open_dead(0, 0);
dump = pcap_dump_open(pc, "/dev/null");
pkt = (u_char*)(pcap_next(pc, &hdr));
pcap_dump((u_char*)dump, &hdr, pkt);
pcap_dump_flush((u_char*)dump);
                     ])],[
                AC_MSG_RESULT([yes])],[
                AC_MSG_RESULT([no])
                SK_ENABLE_PCAP=0])
        fi

        # Restore cached values
        LDFLAGS="$sk_save_LDFLAGS"
        LIBS="$sk_save_LIBS"
        CFLAGS="$sk_save_CFLAGS"
        CPPFLAGS="$sk_save_CPPFLAGS"
    fi

    if test "x$SK_ENABLE_PCAP" != "x1"
    then
        AC_MSG_NOTICE([(${PACKAGE}) Cannot build rwp* tools without pcap])
        PCAP_LDFLAGS=
        PCAP_CFLAGS=
        RPM_SPEC_CONFIGURE="$RPM_SPEC_CONFIGURE --without-pcap"
    else
        SK_CPPFLAGS="$SK_CPPFLAGS $PCAP_CFLAGS"
        AC_DEFINE([HAVE_PCAP_H], 1,
            [Define to 1 if you have the <pcap.h> header file.])
        RPM_SPEC_REQUIRES="$RPM_SPEC_REQUIRES libpcap,"
        RPM_SPEC_BUILDREQUIRES="$RPM_SPEC_BUILDREQUIRES "'%{_includedir}/pcap.h,'
    fi

    AM_CONDITIONAL(HAVE_PCAP, [test "x$SK_ENABLE_PCAP" = x1])

])# SILK_AC_OPT_WITH_PCAP


# ---------------------------------------------------------------------------
# SILK_AC_OPT_WITH_PCRE
#
#    Determine how to use PCRE
#
#    Output variables:  PCRE_CFLAGS PCRE_LDFLAGS
#    Output defines:    HAVE_PCRE_H
#
AC_DEFUN([SILK_AC_OPT_WITH_PCRE],[
    AC_SUBST(PCRE_CFLAGS)
    AC_SUBST(PCRE_LDFLAGS)
    AC_SUBST(SK_ENABLE_PCRE)
    SK_ENABLE_PCRE=0

    silk_require_pcre_version=0

    m4_ifdef([PKG_CHECK_MODULES], [SILK_AC_OPT_WITH_PCRE_PKGCONFIG])

    if test "x$SK_ENABLE_PCRE" = "x1"
    then
        # Cache current values
        sk_save_LDFLAGS="$LDFLAGS"
        sk_save_LIBS="$LIBS"
        sk_save_CFLAGS="$CFLAGS"
        sk_save_CPPFLAGS="$CPPFLAGS"

        PCRE_LDFLAGS="$PCRE_LIBS"
        LIBS="$PCRE_LDFLAGS $LIBS"

        CFLAGS="$PCRE_CFLAGS $CFLAGS"

        AC_MSG_CHECKING([usability of PCRE library and headers])
        AC_LINK_IFELSE(
            [AC_LANG_PROGRAM([
#include <pcre.h>
                ],[
(void) pcre_version ();
                 ])],[
            AC_MSG_RESULT([yes])
            SK_ENABLE_PCRE=1
            ],[
            AC_MSG_RESULT([no])
            SK_ENABLE_PCRE=0])

        # Restore cached values
        LDFLAGS="$sk_save_LDFLAGS"
        LIBS="$sk_save_LIBS"
        CFLAGS="$sk_save_CFLAGS"
        CPPFLAGS="$sk_save_CPPFLAGS"
    fi

    if test "x$SK_ENABLE_PCRE" != "x1"
    then
        PCRE_LDFLAGS=
        PCRE_CFLAGS=
        RPM_SPEC_CONFIGURE="$RPM_SPEC_CONFIGURE --without-pcre"
    else
        RPM_SPEC_REQUIRES="$RPM_SPEC_REQUIRES pcre >= $silk_require_pcre_version,"
        RPM_SPEC_BUILDREQUIRES="$RPM_SPEC_BUILDREQUIRES pcre-devel >= $silk_require_pcre_version,"
    fi
])# SILK_AC_OPT_WITH_PCRE


# ---------------------------------------------------------------------------
# SILK_AC_OPT_WITH_PCRE_PKGCONFIG
#
#    Run the part of --with-pcre that requires pkgconfig
#
AC_DEFUN([SILK_AC_OPT_WITH_PCRE_PKGCONFIG],[
    sk_pkg_config=""
    AC_ARG_WITH([pcre],[AS_HELP_STRING([--with-pcre=DIR],
            [find PCRE package configuration file (libpcre.pc) in the directory DIR (prepends DIR to the PKG_CONFIG_PATH)])[]dnl
        ],[
            if test "x$withval" != "xyes"
            then
                sk_pkg_config="$withval"
            fi
    ])

    if test "x$sk_pkg_config" != "xno"
    then
        if test "x$sk_pkg_config" != "x"
        then
            sk_save_PKG_CONFIG_PATH="$PKG_CONFIG_PATH"
            PKG_CONFIG_PATH="$sk_pkg_config:$PKG_CONFIG_PATH"
            export PKG_CONFIG_PATH
        fi

        PKG_CHECK_MODULES([LIBPCRE], [libpcre >= $silk_require_pcre_version], [SK_ENABLE_PCRE=1], [SK_ENABLE_PCRE=0])

        if test "x$sk_pkg_config" != "x"
        then
            PKG_CONFIG_PATH="$sk_save_PKG_CONFIG_PATH"
            export PKG_CONFIG_PATH
        fi
    fi
])# SILK_AC_OPT_WITH_PCRE_PKGCONFIG


# ---------------------------------------------------------------------------
# SILK_AC_OPT_WITH_PYTHON
#
#    Set up python environment.
#
AC_DEFUN([SILK_AC_OPT_WITH_PYTHON],[

    # Variables required when building with Python
    AC_SUBST(PYTHON_CPPFLAGS)
    AC_SUBST(PYTHON_LDFLAGS)
    AC_SUBST(PYTHON_LDFLAGS_EMBEDDED)
    AC_SUBST(PYTHON_SO_EXTENSION)

    # Variables containing Python install locations
    AC_SUBST(PYTHON_SITE_PKG)
    AC_SUBST(PYTHON_DEFAULT_SITE_PKG)

    # A version of the above with all variables expanded
    AC_SUBST(SILK_PYTHON_SITE_PKG)

    # Variables to be compatible with AM_PATH_PYTHON()
    AC_SUBST([pythondir], [\${PYTHON_SITE_PKG}])
    AC_SUBST([pkgpythondir], [\${pythondir}/$PACKAGE])

    # Variables we need to use in the silk.spec file for RPM
    AC_SUBST(RPM_SPEC_WITH_PYTHON)
    AC_SUBST(RPM_SPEC_PYTHON_SITEPKG_SILK)

    # Name of the script we use to get information from Python,
    # relative to srcdir.  Export it for "make dist" purposes.
    AC_SUBST([PYTHON_INFO_PROG], [autoconf/silk-python-info.py])

    # Path to our python information script
    python_info="${srcdir}/$PYTHON_INFO_PROG"

    # The result of running that script
    python_info_result="./python-config.sh"

    # Possible names for the python interpreter
    python_names="python python2 python2.5 python2.4 no"

    AC_ARG_VAR([PYTHON], [The Python interpreter to use for PySiLK support when no interpreter is specified to --with-python; must be Python 2.4 or later.])

    AC_ARG_WITH([python],
        [AS_HELP_STRING([[[[--with-python[=PYTHON]]]]],
            [add PySiLK "SiLK in Python" support.  If an argument is provided, it is the path to the Python interpreter to use [no]])[]dnl
        ],[
        if test "x$withval" = "xno"
        then
            SK_ENABLE_PYTHON=0
        elif test "x$withval" = "xyes"
        then
            SK_ENABLE_PYTHON=1
        else
            # Treat the argument as the python interpreter
            PYTHON="$withval"
            SK_ENABLE_PYTHON=1
        fi],
        [SK_ENABLE_PYTHON=0])

    if test "x$SK_ENABLE_PYTHON" = "x1"
    then
        AC_MSG_NOTICE([(${PACKAGE}) Determining Python settings for PySiLK support])
    fi

    AC_ARG_WITH([python-prefix],
        [AS_HELP_STRING([[[[--with-python-prefix[=DIR]]]]],
            [install the "silk" Python module under this prefix instead of in the Python site directory.  An empty argument means to use the value of PREFIX])[]dnl
        ],[
        if test "x$withval" = "xyes"
        then
            sk_PYTHONPREFIX='${prefix}'
        elif test "x$withval" != "xno"
        then
            sk_PYTHONPREFIX="$withval"
        fi
        ])

    AC_ARG_WITH([python-site-dir],
        [AS_HELP_STRING([--with-python-site-dir=DIR],
            [install the files for the PySiLK module in DIR/silk/* instead of in the Python site directory])[]dnl
        ],[
        if test "x$withval" = "xyes"
        then
            AC_MSG_ERROR([--with-python-site-dir requires an argument])
        elif test "x$withval" != "xno"
        then
            if test "x$sk_PYTHONPREFIX" != "x"
            then
                AC_MSG_ERROR([--with-python-site-dir cannot be used with --with-python-prefix])
            fi
            sk_PYTHONSITEDIR="$withval"
        fi
        ])

    # If --with-python is specified but there is no interpreter, find
    # one
    if test "x$SK_ENABLE_PYTHON" = "x1" && test "x$PYTHON" = "x"
    then
        AC_MSG_CHECKING([for a Python program])
        for maybe_python in $python_names
        do
            if test $maybe_python = no
            then
                break
            fi
            echo "$as_me:$LINENO: $maybe_python \"$python_info\" --check-version >&AS_MESSAGE_LOG_FD" >&AS_MESSAGE_LOG_FD
            $maybe_python "$python_info" --check-version >&AS_MESSAGE_LOG_FD 2>&1
            python_status=$?
            echo "$as_me:$LINENO: \$? = $python_status" >&AS_MESSAGE_LOG_FD

            if test $python_status -eq 0
            then
                break
            fi
        done
        if test "$maybe_python" != "no"
        then
            SK_ENABLE_PYTHON=1
            PYTHON=$maybe_python
            AC_MSG_RESULT([$PYTHON])
        else
            SK_ENABLE_PYTHON=0
            AC_MSG_RESULT([none found. PySiLK support disabled.])
        fi
    fi

    # Get the required info from python
    if test "x$SK_ENABLE_PYTHON" = "x1"
    then
        AC_PATH_PROG([PYTHON], [$PYTHON], [no])
        if test "x$PYTHON" = "xno" || test ! -x "$PYTHON"
        then
            AC_MSG_ERROR([Specified Python program '$PYTHON' does not exist])
        fi
        AC_MSG_CHECKING([whether $PYTHON supports PySiLK])

        echo "$as_me:$LINENO: \"$PYTHON\" \"$python_info\" --check-version >&AS_MESSAGE_LOG_FD" >&AS_MESSAGE_LOG_FD
        "$PYTHON" "$python_info" --check-version >&AS_MESSAGE_LOG_FD 2>&1
        python_status=$?
        echo "$as_me:$LINENO: \$? = $python_status" >&AS_MESSAGE_LOG_FD

        if test $python_status -eq 0
        then
            AC_MSG_RESULT([yes])
        else
            AC_MSG_RESULT([no])
            AC_MSG_FAILURE([PySiLK cannot use the Python program '$PYTHON'])
        fi

        # remove old script result
        rm -f $python_info_result

        # run the python-info script
        echo "$as_me:$LINENO: PYTHONPREFIX=\"$sk_PYTHONPREFIX\" PYTHONSITEDIR=\"$sk_PYTHONSITEDIR\" \"$PYTHON\" \"$python_info\" --filename \"$python_info_result\"" >&AS_MESSAGE_LOG_FD
        PYTHONPREFIX="$sk_PYTHONPREFIX" PYTHONSITEDIR="$sk_PYTHONSITEDIR" "$PYTHON" "$python_info" --filename "$python_info_result"
        python_status=$?
        echo "$as_me:$LINENO: \$? = $python_status" >&AS_MESSAGE_LOG_FD

        # pull in results from the script
        if test $python_status -eq 0 && test -f "$python_info_result"
        then
            . "$python_info_result"
        else
            AC_MSG_FAILURE([failed to execute '$PYTHON $python_info'])
        fi

        # verify that we have a version
        if test -z "$PYTHON_VERSION"
        then
            AC_MSG_ERROR([error running '$PYTHON $python_info'])
        fi

        # print results
        AC_MSG_CHECKING([for Python version])
        AC_MSG_RESULT($PYTHON_VERSION)

        AC_MSG_CHECKING([for Python site file directory])
        AC_MSG_RESULT($PYTHON_SITE_PKG)

        AC_MSG_CHECKING([for Python CPPFLAGS])
        if test "x$PYTHON_CPPFLAGS" = "x"
        then
            AC_MSG_RESULT([none])
        else
            AC_MSG_RESULT($PYTHON_CPPFLAGS)
        fi

        AC_MSG_CHECKING([for Python LDFLAGS])
        # Replace Python's version of pthread flags with our own
        if test "x$PYTHON_LDFLAGS_PTHREAD" != "x"
        then
            if test "x$PYTHON_LDFLAGS" != "x"
            then
                PYTHON_LDFLAGS="$PYTHON_LDFLAGS $PTHREAD_LDFLAGS"
            else
                PYTHON_LDFLAGS="$PTHREAD_LDFLAGS"
            fi
        fi
        if test "x$PYTHON_LDFLAGS" = "x"
        then
            AC_MSG_RESULT([none])
        else
            AC_MSG_RESULT($PYTHON_LDFLAGS)
        fi

        AC_MSG_CHECKING([for Python embedded LDFLAGS])
        if test "x$PYTHON_LDFLAGS_EMBEDDED_PTHREAD" != "x"
        then
            if test "x$PYTHON_LDFLAGS_EMBEDDED" != "x"
            then
                PYTHON_LDFLAGS_EMBEDDED="$PYTHON_LDFLAGS_EMBEDDED $PTHREAD_LDFLAGS"
            else
                PYTHON_LDFLAGS_EMBEDDED="$PTHREAD_LDFLAGS"
            fi
        fi
        if test "x$PYTHON_LDFLAGS_EMBEDDED" = "x"
        then
            AC_MSG_RESULT([none])
        else
            AC_MSG_RESULT($PYTHON_LDFLAGS_EMBEDDED)
        fi

        AC_MSG_CHECKING([for Python shared library filename extension])
        AC_MSG_RESULT($PYTHON_SO_EXTENSION)

        # verify that the library and header files are usable.  first,
        # cache current values
        sk_save_LDFLAGS="$LDFLAGS"
        sk_save_LIBS="$LIBS"
        sk_save_CPPFLAGS="$CPPFLAGS"

        # add python values
        LDFLAGS="$sk_save_LDFLAGS $PYTHON_LDFLAGS_EMBEDDED"
        CPPFLAGS="$sk_save_CPPFLAGS $PYTHON_CPPFLAGS"

        AC_MSG_CHECKING([usability of $PYTHON_LIBNAME library and headers])
        AC_LINK_IFELSE(
            [AC_LANG_PROGRAM([
#include <Python.h>
                ],[
Py_InitializeEx(1);
                ])],[
            AC_MSG_RESULT([yes])],[
            AC_MSG_RESULT([no])
            AC_MSG_FAILURE([Unable to use Python])
        ])

        # restore cached values
        LDFLAGS="$sk_save_LDFLAGS"
        LIBS="$sk_save_LIBS"
        CPPFLAGS="$sk_save_CPPFLAGS"

        AC_MSG_CHECKING([for system-specific Python problems])
        if test -n "$PYTHON_ERROR"
        then
            AC_MSG_ERROR([python error: ${PYTHON_ERROR}])
        fi
        AC_MSG_RESULT([none])

        rm -f $python_info_result
        SK_ENABLE_PYTHON=1
    else
        SK_ENABLE_PYTHON=0
    fi

    # Set variables used in the RPM spec file
    if test "x$SK_ENABLE_PYTHON" = "x0"
    then
        AC_MSG_NOTICE([(${PACKAGE}) Building without PySiLK support])

        RPM_SPEC_CONFIGURE="$RPM_SPEC_CONFIGURE --without-python"
        RPM_SPEC_WITH_PYTHON=0
        RPM_SPEC_PYTHON_SITEPKG_SILK=NONE
    else
        AC_MSG_NOTICE([(${PACKAGE}) Including PySiLK support])

        # Get version with all variables expanded
        SILK_PYTHON_SITE_PKG=`eval "echo $PYTHON_SITE_PKG"`

        RPM_SPEC_CONFIGURE="$RPM_SPEC_CONFIGURE --with-python"
        if test "x$sk_PYTHONPREFIX" != "x"
        then
            RPM_SPEC_CONFIGURE="$RPM_SPEC_CONFIGURE --with-python-prefix='$sk_PYTHONPREFIX'"
        elif test "x$sk_PYTHONSITEDIR" != "x"
        then
            RPM_SPEC_CONFIGURE="$RPM_SPEC_CONFIGURE --with-python-site-dir='$sk_PYTHONSITEDIR'"
        fi
        RPM_SPEC_REQUIRES="$RPM_SPEC_REQUIRES python >= 2.4,"
        RPM_SPEC_BUILDREQUIRES="$RPM_SPEC_BUILDREQUIRES python-devel >= 2.4,"
        RPM_SPEC_WITH_PYTHON=1
        # Where we finally want them to be installed.
        # Change '\$' to '%' for the spec file.
        RPM_SPEC_PYTHON_SITEPKG_SILK=`echo "${PYTHON_SITE_PKG}/${PACKAGE}" | sed 's/\\$/%/g'`
    fi

    AM_CONDITIONAL([HAVE_PYTHON], [test "x$SK_ENABLE_PYTHON" = "x1"])

])# SILK_AC_PYTHON


# ---------------------------------------------------------------------------
# SILK_AC_OPT_WITH_ZLIB
#
#    Determine how to use zlib
#
AC_DEFUN([SILK_AC_OPT_WITH_ZLIB],[
    AC_SUBST([SK_ENABLE_ZLIB])
    SK_ENABLE_ZLIB=0

    AC_ARG_WITH([zlib],[AS_HELP_STRING([--with-zlib=ZLIB_DIR],
            [find zlib.h in ZLIB_DIR/include, libz in ZLIB_DIR/lib])[]dnl
        ],[
            if test "x$withval" != "xyes"
            then
                zlib_dir="$withval"
                zlib_includes="$zlib_dir/include"
                zlib_libraries="$zlib_dir/lib"
            fi
    ])
    AC_ARG_WITH([zlib-includes],[AS_HELP_STRING([--with-zlib-includes=DIR],
            [find zlib.h in DIR (overrides ZLIB_DIR/include)])[]dnl
        ],[
            if test "x$withval" = "xno"
            then
                zlib_dir=no
            elif test "x$withval" != "xyes"
            then
                zlib_includes="$withval"
            fi
    ])
    AC_ARG_WITH([zlib-libraries],[AS_HELP_STRING([--with-zlib-libraries=DIR],
            [find libzlib in DIR (overrides ZLIB_DIR/lib)])[]dnl
        ],[
            if test "x$withval" = "xno"
            then
                zlib_dir=no
            elif test "x$withval" != "xyes"
            then
                zlib_libraries="$withval"
            fi
    ])

    if test "x$zlib_dir" != "xno"
    then
        # Cache current values
        sk_save_LDFLAGS="$LDFLAGS"
        sk_save_LIBS="$LIBS"
        sk_save_CFLAGS="$CFLAGS"
        sk_save_CPPFLAGS="$CPPFLAGS"

        ZLIB_LDFLAGS="-lz"
        if test "x$zlib_libraries" != "x"
        then
            ZLIB_LDFLAGS="-L$zlib_libraries $ZLIB_LDFLAGS"
        fi
        LIBS="$ZLIB_LDFLAGS $LIBS"

        if test "x$zlib_includes" != "x"
        then
            ZLIB_CFLAGS="-I$zlib_includes"
            CFLAGS="$ZLIB_CFLAGS $CFLAGS"
        fi

        AC_CHECK_LIB([z], [gzopen], [SK_ENABLE_ZLIB=1])

        if test "x$SK_ENABLE_ZLIB" = "x1"
        then
            AC_CHECK_HEADER([zlib.h], , [
                AC_MSG_WARN([Found libz but not zlib.h.  Maybe you should install zlib-devel?])
                SK_ENABLE_ZLIB=0])
        fi

        if test "x$SK_ENABLE_ZLIB" = "x1"
        then
            # found zlib, now look for the compressBound() function
            AC_CHECK_LIB([z], [compressBound],
                AC_DEFINE([HAVE_COMPRESSBOUND], 1,
                    [Define to 1 if your zlib library provides compressBound().]))
        fi

        # Restore cached values
        LDFLAGS="$sk_save_LDFLAGS"
        LIBS="$sk_save_LIBS"
        CFLAGS="$sk_save_CFLAGS"
        CPPFLAGS="$sk_save_CPPFLAGS"
    fi

    if test "x$SK_ENABLE_ZLIB" != "x1"
    then
        RPM_SPEC_CONFIGURE="$RPM_SPEC_CONFIGURE --without-zlib"
    else
        SK_CPPFLAGS="$SK_CPPFLAGS $ZLIB_CFLAGS"
        SK_LIBS="$ZLIB_LDFLAGS $SK_LIBS"
        SK_BASIC_HEADERS="$SK_BASIC_HEADERS <zlib.h>"
        RPM_SPEC_REQUIRES="$RPM_SPEC_REQUIRES zlib,"
        RPM_SPEC_BUILDREQUIRES="$RPM_SPEC_BUILDREQUIRES zlib-devel,"
    fi

    AM_CONDITIONAL(HAVE_ZLIB, [test "x$SK_ENABLE_ZLIB" = x1])

])# SILK_AC_OPT_WITH_ZLIB


# ---------------------------------------------------------------------------
# SILK_AC_PREPROC_ADDITIONAL_FLAGS(var, flag_list)
#
#    For each flag listed in FLAG_LIST, add it to the specified VAR if
#    the preprocessor understands it.
#
AC_DEFUN([SILK_AC_PREPROC_ADDITIONAL_FLAGS],[
    # cache the old CPPFLAGS value
    sk_save_CPPFLAGS="$CPPFLAGS"

    for sk_cpp_flag in $2
    do
        CPPFLAGS="$sk_cpp_flag $sk_save_CPPFLAGS"
        AC_MSG_CHECKING([whether the preprocessor understands $sk_cpp_flag])
        AC_PREPROC_IFELSE(
            [AC_LANG_PROGRAM([],[
                 int x; x++;
                 ])
            ],[
                $1="$$1 $sk_cpp_flag"
                AC_MSG_RESULT([yes])],
            [AC_MSG_RESULT([no])])
    done

    CPPFLAGS="$sk_save_CPPFLAGS"
])#SILK_AC_PREPROC_ADDITIONAL_FLAGS


# ---------------------------------------------------------------------------
# SILK_AC_PTHREAD_LDFLAGS
#
#    Determine how to use pthreads.  Output variables: PTHREAD_LDFLAGS
#
AC_DEFUN([SILK_AC_PTHREAD_LDFLAGS],[
    AC_SUBST(PTHREAD_LDFLAGS)

    AC_MSG_CHECKING([for pthread linker flags])

    # cache current LIBS
    sk_save_LIBS="$LIBS"

    # pthreads requires libexc on OSF/1 or TruUNIX or Tru64 or
    # whatever it is called by DEC or Compaq or HP or whatever they
    # are calling themselves now

    for sk_pthread in "X" "X-pthread" "X-lpthread" "X-lpthread -lexc"
    do
        sk_pthread=`echo $sk_pthread | sed 's/^X//'`
        LIBS="$sk_pthread $sk_save_LIBS"

        # This is a RUN because Solaris will successfully link the
        # program and just leave out the pthread calls!
        AC_RUN_IFELSE([
            AC_LANG_PROGRAM([
#include <stdio.h>
#if HAVE_STDLIB_H
#include <stdlib.h>
#endif
#if HAVE_UNISTD_H
#include <unistd.h>
#endif
#if HAVE_PTHREAD_H
#include <pthread.h>
#endif

static void *dummy(void *v)
{
  return v;
}
                ],[
pthread_t p;
int x = 0;
void *xp = NULL;

pthread_create(&p, NULL, dummy, &x);
pthread_join(p, &xp);
if (xp != &x) return 1;
])],[
            PTHREAD_LDFLAGS="$sk_pthread"
            if test "x$sk_pthread" = "x"
            then
                AC_MSG_RESULT([none required])
            else
                AC_MSG_RESULT([$PTHREAD_LDFLAGS])
            fi
            break])
    done

    # restore libs
    LIBS="$sk_save_LIBS"
])# SILK_AC_PTHREAD_LDFLAGS


# ---------------------------------------------------------------------------
# SILK_AC_PTHREAD_RWLOCK
#
#    Determine whether pthread supports read-write locks.
#    Output variable: HAVE_PTHREAD_RWLOCK
#
AC_DEFUN([SILK_AC_PTHREAD_RWLOCK],[

    AC_MSG_CHECKING([for pthread read/write locks])

    # cache current LIBS
    sk_save_LIBS="$LIBS"

    # add pthread library
    LIBS="$LIBS $PTHREAD_LDFLAGS"

    # This is a RUN because Solaris will successfully link the
    # program and just leave out the pthread calls!
    AC_RUN_IFELSE([
        AC_LANG_PROGRAM([
#include <stdio.h>
#if HAVE_STDLIB_H
#include <stdlib.h>
#endif
#if HAVE_ERRNO_H
#include <errno.h>
#endif
#if HAVE_PTHREAD_H
#include <pthread.h>
#endif
#define FAILIF(x) if (x) { return 1; }
            ],[
    pthread_rwlock_t lock;
    int rv;
    rv = pthread_rwlock_init(&lock, NULL);
    FAILIF(rv != 0);
    rv = pthread_rwlock_tryrdlock(&lock);
    FAILIF(rv != 0);
    rv = pthread_rwlock_trywrlock(&lock);
    FAILIF(rv != EBUSY);
    rv = pthread_rwlock_tryrdlock(&lock);
    FAILIF(rv != 0);
    rv = pthread_rwlock_trywrlock(&lock);
    FAILIF(rv != EBUSY);
    rv = pthread_rwlock_unlock(&lock);
    FAILIF(rv != 0);
    rv = pthread_rwlock_trywrlock(&lock);
    FAILIF(rv != EBUSY);
    rv = pthread_rwlock_unlock(&lock);
    FAILIF(rv != 0);
    rv = pthread_rwlock_trywrlock(&lock);
    FAILIF(rv != 0);
    rv = pthread_rwlock_tryrdlock(&lock);
    FAILIF(rv != EBUSY);
    rv = pthread_rwlock_trywrlock(&lock);
    FAILIF(rv != EBUSY);
    rv = pthread_rwlock_unlock(&lock);
    FAILIF(rv != 0);
    rv = pthread_rwlock_tryrdlock(&lock);
    FAILIF(rv != 0);
    rv = pthread_rwlock_unlock(&lock);
    FAILIF(rv != 0);
    rv = pthread_rwlock_destroy(&lock);
    FAILIF(rv != 0);
    return 0;
            ])],[
           AC_MSG_RESULT([yes])
           AC_DEFINE([HAVE_PTHREAD_RWLOCK], 1,
                     [Define to 1 if your system has working pthread read/write locks])
            ],[
           AC_MSG_RESULT([no])
        ])

    # restore libs
    LIBS="$sk_save_LIBS"
])# SILK_AC_PTHREAD_RWLOCK


# ---------------------------------------------------------------------------
# SILK_AC_STD_SUBSTS
#
#    Do final substitutions
#
AC_DEFUN([SILK_AC_STD_SUBSTS],[

    LIBS="$SK_LIBS $LIBS"

    # Build up list of basic headers to put into silk_config.h
    sk_bh_count=1
    for sk_bh_hdr in $SK_BASIC_HEADERS
    do
        sk_bh_var=SK_BASIC_HEADERS_`printf "%02d" $sk_bh_count`
        eval "$sk_bh_var='#include $sk_bh_hdr'"
        sk_bh_count=`expr $sk_bh_count + 1`
    done

    RPM_SPEC_REQUIRES=`echo "$RPM_SPEC_REQUIRES" | sed 's/,$//'`
    RPM_SPEC_BUILDREQUIRES=`echo "$RPM_SPEC_BUILDREQUIRES" | sed 's/,$//'`

    if test -n "$ac_cv_path_MAILX"
    then
       AC_DEFINE_UNQUOTED([SK_MAILER],"$ac_cv_path_MAILX",[Path to mail program used for sending alerts])
    fi
]) # SILK_AC_STD_SUBSTS


# ---------------------------------------------------------------------------
# SILK_AC_WRITE_SUMMARY
#
#    Write a summary of configure to a file
#
AC_DEFUN([SILK_AC_WRITE_SUMMARY],[
    AC_SUBST(SILK_SUMMARY_FILE)
    SILK_SUMMARY_FILE=silk-summary.txt

    # Get the prefix
    sk_summary_prefix="$prefix"
    if test "x$sk_summary_prefix" = xNONE
    then
        sk_summary_prefix="$ac_default_prefix"
    fi

    SILK_FINAL_MSG="
    * Configured package:           ${PACKAGE_STRING}
    * Host type:                    ${build}
    * Source files (\$top_srcdir):   $srcdir
    * Install directory:            $sk_summary_prefix
    * Root of packed data tree:     $SILK_DATA_ROOTDIR"

    if test "x$PACKING_LOGIC_PATH" = "x"
    then
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * Packing logic:                via run-time plugin"
    else
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * Packing logic:                $PACKING_LOGIC_PATH"
    fi

    if test "x$SK_ENABLE_LOCALTIME" = "x1"
    then
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * Timezone support:             local"
    else
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * Timezone support:             UTC"
    fi

    SILK_FINAL_MSG="$SILK_FINAL_MSG
    * Default compression method:   $SK_ENABLE_OUTPUT_COMPRESSION"

    if test "x$SK_ENABLE_IPV6" = "x1"
    then
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * IPv6 support (experimental):  YES"
    else
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * IPv6 support:                 NO"
    fi

    if test "x$SK_ENABLE_IPFIX" = "x1"
    then
        sk_msg_ldflags=`echo " $FIXBUF_LDFLAGS" | sed 's/^ *//' | sed 's/ *$//'`
        if test -n "$sk_msg_ldflags"
        then
            sk_msg_ldflags=" ($sk_msg_ldflags)"
        fi
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * IPFIX collection support:     YES$sk_msg_ldflags"
    else
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * IPFIX collection support:     NO"
    fi



    if test "x$SK_ENABLE_GNUTLS" = "x0"
    then
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * Transport encryption support: NO (gnutls not found)"
    else
        sk_msg_ldflags=`echo "$GNUTLS_LDFLAGS" | sed 's/^ *//' | sed 's/ *$//'`
        if test -n "$sk_msg_ldflags"
        then
            sk_msg_ldflags=" ($sk_msg_ldflags)"
        fi
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * Transport encryption support: YES$sk_msg_ldflags"
    fi

    if test "x$SK_ENABLE_IPA" = "x1"
    then
        sk_msg_ldflags=`echo "$LIBIPA_LDFLAGS" | sed 's/^ *//' | sed 's/ *$//'`
        if test -n "$sk_msg_ldflags"
        then
            sk_msg_ldflags=" ($sk_msg_ldflags)"
        fi
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * IPA support:                  YES$sk_msg_ldflags"
    else
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * IPA support:                  NO"
    fi

    if test "x$SK_ENABLE_PCAP" = "x1"
    then
        sk_msg_ldflags=`echo "$PCAP_LDFLAGS" | sed 's/^ *//' | sed 's/ *$//'`
        if test -n "$sk_msg_ldflags"
        then
            sk_msg_ldflags=" ($sk_msg_ldflags)"
        fi
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * LIBPCAP support:              YES$sk_msg_ldflags"
    else
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * LIBPCAP support:              NO"
    fi

    if test "x$SK_ENABLE_PYTHON" = "x1"
    then
        sk_msg_ldflags=`echo "$PYTHON_LDFLAGS_EMBEDDED" | sed 's/^ *//' | sed 's/ *$//'`
        if test -n "$sk_msg_ldflags"
        then
            sk_msg_ldflags=" ($sk_msg_ldflags)"
        fi
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * Python support:               YES$sk_msg_ldflags
    * Python package destination:   $PYTHON_SITE_PKG"
    else
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * Python support:               NO"
    fi

#   if test "x$SK_ENABLE_PCRE" = "x1"
#   then
#       sk_msg_ldflags=`echo "$PCRE_LDFLAGS" | sed 's/^ *//' | sed 's/ *$//'`
#       if test -n "$sk_msg_ldflags"
#       then
#           sk_msg_ldflags=" ($sk_msg_ldflags)"
#       fi
#       SILK_FINAL_MSG="$SILK_FINAL_MSG
#   * PCRE support:                 YES$sk_msg_ldflags"
#   else
#       SILK_FINAL_MSG="$SILK_FINAL_MSG
#   * PCRE support:                 NO"
#   fi

    if test "x$silk_enable_analysis_tools" = "x0"
    then
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * Build analysis tools:         NO (--disable-analysis-tools)"
    else
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * Build analysis tools:         YES"
    fi

    if test "x$silk_enable_packing_tools" = "x0"
    then
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * Build packing tools:          NO (--disable-packing-tools)"
    else
        SILK_FINAL_MSG="$SILK_FINAL_MSG
    * Build packing tools:          YES"
    fi

    # Remove leading whitespace
    sk_msg_cflags="$CPPFLAGS $SK_CPPFLAGS $CFLAGS $SK_CFLAGS $WARN_CFLAGS"
    sk_msg_cflags=`echo "$sk_msg_cflags" | sed 's/^ *//' | sed 's/  */ /g'`

    sk_msg_ldflags="$SK_LDFLAGS $LDFLAGS"
    sk_msg_ldflags=`echo "$sk_msg_ldflags" | sed 's/^ *//' | sed 's/  */ /g'`

    SILK_FINAL_MSG="$SILK_FINAL_MSG
    * Compiler (CC):                $CC
    * Compiler flags (CFLAGS):      $sk_msg_cflags
    * Linker flags (LDFLAGS):       $sk_msg_ldflags
    * Libraries (LIBS):             $LIBS
"

    echo "$SILK_FINAL_MSG" > $SILK_SUMMARY_FILE

    AC_CONFIG_COMMANDS([silk_summary],[
        if test -f $SILK_SUMMARY_FILE
        then
            cat $SILK_SUMMARY_FILE
        fi],[SILK_SUMMARY_FILE=$SILK_SUMMARY_FILE])

]) # SILK_AC_WRITE_SUMMARY


dnl Local Variables:
dnl mode:autoconf
dnl indent-tabs-mode:nil
dnl End:
